# a fresh start

## what things do I want to be able to do?

1. sync the entire npm registry (just metadata, or metadata+tarballs) from
   npmjs.org to a usb stick
2. sync metadata or meta+tarballs from a usb stick to my local index
3. install packages from my local index / cache
4. on a LAN with a friend: install packages from each other
5. install packages by using my local index's metadata, but get tarballs from
   {npmjs.org, hyperdrive + discovery-channel, usb stick, local cache}
6. use a remote source's metadata AND/OR tarballs on-demand to install packages
7. bonus: share packages with friends in same physical space /wo a local network
   (audio? bluetooth? screen-flashing?)

## registries

each registry is kind of like a git remote. you can

1. request metadata and tarballs on-demand
2. sync all or partial metadata from that remote to your local index
3. sync all or partial tarballs from that remote to your local index
4. (eventually) publish a package to that remote

## operation

let's make this pretty simple, eh?

1. `peer-npm registry add usb /var/media/my_usb/registry` to add a registry source
   from FS
2. `peer-npm registry add npm https://registry.npmjs.org` to add official npm
   registry
3. `peer-npm registry add juul hyperdrive://JUUL_HEX_PUBLIC_KEY` to say I trust
   juul, if I find him via mDNS or bittorrent
4. `peer-npm sync npm --metadata` to pull metadata into local index
5. `peer-npm install foobar` uses indexed local metadata + mDNS/bittorrent to
   find peers and download required tarballs

## how would it work if I wanted to be more p2p network focused?

- all peers mirror their npm cache to hyperdiscovery and fetch meta+tarballs on
  demand

## unix design

### Do one thing well.
### Be a filter.
### Generalize.
Plug in any remote you want and do metadata and tarball syncing with it!
### Be robust.
I think the remote-style interface makes the tool both robust and extensible.
### Be new.

## modules

- `registry-shell`: combine with an http server to have an interface for
  satisfying npm registry requests

